{{/*
Common labels
*/}}
{{- define "stepfunction.labels" -}}
{{ include "stepfunction-utils.labels" . }}
{{- end -}}

{{/*
Selector labels
*/}}
{{- define "stepfunction.selectorLabels" -}}
{{ include "stepfunction-utils.selectorLabels" . }}
{{- end -}}

{{- define "_stepfunction.requiredStateMachineName" -}}
{{- required "You must specify the 'stateMachineName' to be created" .Values.stateMachineName -}}
{{- end -}}

{{- define "_stepfunction.fullStateMachineName" -}}
{{ include "stepfunction-utils.externalNamingPrefix" . }}-{{ include "_stepfunction.requiredStateMachineName" .}}
{{- end -}}

{{- define "stepfunction.stateMachineName" -}}
{{- $stateMachineName:= ( include "_stepfunction.fullStateMachineName" . ) -}}
{{- if not (mustRegexMatch "^[a-zA-Z0-9_.-]+$" .Values.stateMachineName) -}}
{{- fail "'stateMachineName' failed to satisfy constraint: Member must satisfy regular expression pattern: [a-zA-Z0-9_.-]+" -}}
{{- end -}}
{{- $lenStateMachineName := $stateMachineName | len | float64 -}}
{{- if ge $lenStateMachineName .Values.maxNameLength -}}
{{- printf "\nThe generated stateMachineName %s is greater than the allowed number of characters %f." $stateMachineName .Values.maxNameLength | fail -}}
{{- else -}}
{{- printf "%s" $stateMachineName -}}
{{- end -}}
{{- end -}}